/*
 * @author Ranides Atterwim <ranides@gmail.com>
 * @copyright Ranides Atterwim
 * @license WTFPL
 * @url http://ranides.net/projects/assira
 */
package net.ranides.assira.reflection.util;

import java.lang.reflect.Method;
import static net.ranides.assira.reflection.util.MemberUtils.isGetter;
import static net.ranides.assira.reflection.util.MemberUtils.isSetter;
import net.ranides.assira.text.StringUtils;

/**
 *
 * @author Ranides Atterwim <ranides@gmail.com>
 */
public final class BeanUtils {
    
    private BeanUtils() {
        // utility class
    }

    /**
     * Zwraca nazwę właściwości, którą odczytuje/modyfikuje podana metoda:<br/>
     * {@code getProperty => property}<br/>
     * {@code setProperty => property}<br/>
     * {@code isProperty => property}
     * 
     * @param text
     * @return
     */
    public static String asPropertyName(Method method) {
        String name = method.getName();
        if(name.startsWith("is") && isGetter(method) ) {
            return StringUtils.uncapitalize(name.substring(2));
        }
        if( name.startsWith("get") && isGetter(method) ) {
            return StringUtils.uncapitalize(name.substring(3));
        }
        if( name.startsWith("set") && isSetter(method) ) {
            return StringUtils.uncapitalize(name.substring(3));
        }
        return name;
    }
    
    /**
     * Zwraca nazwę właściwości, którą odczytuje/modyfikuje podana metoda:<br/>
     * {@code getProperty => property}<br/>
     * {@code setProperty => property}<br/>
     * {@code isProperty => property}<br/>
     * Nie wykonuje wszystkich sprawdzeń, czy metoda spełnia kryteria - jedynie
     * transformuje nazwę.
     * @param text
     * @return
     */
    public static String $asPropertyName(Method method) {
        String name = method.getName();
        if(name.startsWith("is") ) {
            return StringUtils.uncapitalize(name.substring(2));
        }
        if( name.startsWith("get") ) {
            return StringUtils.uncapitalize(name.substring(3));
        }
        if( name.startsWith("set") ) {
            return StringUtils.uncapitalize(name.substring(3));
        }
        
        return name;
    }
    
}
